# -*- coding: utf-8 -*-
from setuphelpers import *
import bs4 as BeautifulSoup

bin_contains = "TeamViewerPortable"


def update_package():
    # Declaring local variables
    result = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
    url = "https://www.teamviewer.com/en/download/windows/"
    download_url = "https://download.teamviewer.com/download/TeamViewerPortable.zip"
    latest_bin = download_url.split("/")[-1]

    # Getting latest version from official website
    print("URL used is: %s" % url)
    for elem in bs_find_all("https://www.teamviewer.com/en-us/download/windows/", "div", "class", "wpb_wrapper", proxies=proxies, timeout=10):
        if "Current version" in elem.text:
            version = elem.text.split(": ")[1].split("\n")[0]
            break

    print("Latest %s version is: %s" % (app_name, version))
    print("Download URL is: %s" % download_url)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)

        # Checking version from file
        version_from_file = ".".join(get_version_from_binary(latest_bin).split(".")[:3])
        # if not version_from_file.startswith(version) and version_from_file != '':
        if Version(version_from_file) != Version(version) and version_from_file != "":
            print("Changing version to the version number of the binary")
            version = version_from_file
        else:
            print("Binary file version corresponds to online version")

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        result = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    # control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating update-package-sources
    return result
